/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.records.VCoreVariableRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreVariable extends TableImpl<VCoreVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_variable</code>
     */
    public static final VCoreVariable V_CORE_VARIABLE = new VCoreVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreVariableRecord> getRecordType() {
        return VCoreVariableRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_variable.lastchange</code>.
     */
    public final TableField<VCoreVariableRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_core_variable.pk</code>.
     */
    public final TableField<VCoreVariableRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_variable.fk_element</code>.
     */
    public final TableField<VCoreVariableRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_variable.data_type</code>.
     */
    public final TableField<VCoreVariableRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    /**
     * The column <code>common_dd.v_core_variable.fk_valuelist</code>.
     */
    public final TableField<VCoreVariableRecord, Integer> FK_VALUELIST = createField(DSL.name("fk_valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_variable.fk_missinglist</code>.
     */
    public final TableField<VCoreVariableRecord, Integer> FK_MISSINGLIST = createField(DSL.name("fk_missinglist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_variable.fk_unit</code>.
     */
    public final TableField<VCoreVariableRecord, Integer> FK_UNIT = createField(DSL.name("fk_unit"), SQLDataType.INTEGER, this, "");

    private VCoreVariable(Name alias, Table<VCoreVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreVariable(Name alias, Table<VCoreVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_variable" as  SELECT lastchange,
         pk_core_variable AS pk,
         key_variable AS fk_element,
         data_type,
         fk_var_valuelist AS fk_valuelist,
         fk_missinglist,
         fk_unit
        FROM common_dd.t_core_variable;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_variable</code> table reference
     */
    public VCoreVariable(String alias) {
        this(DSL.name(alias), V_CORE_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_variable</code> table reference
     */
    public VCoreVariable(Name alias) {
        this(alias, V_CORE_VARIABLE);
    }

    /**
     * Create a <code>common_dd.v_core_variable</code> table reference
     */
    public VCoreVariable() {
        this(DSL.name("v_core_variable"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreVariable as(String alias) {
        return new VCoreVariable(DSL.name(alias), this);
    }

    @Override
    public VCoreVariable as(Name alias) {
        return new VCoreVariable(alias, this);
    }

    @Override
    public VCoreVariable as(Table<?> alias) {
        return new VCoreVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariable rename(String name) {
        return new VCoreVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariable rename(Name name) {
        return new VCoreVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariable rename(Table<?> name) {
        return new VCoreVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariable where(Condition condition) {
        return new VCoreVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
